c theta_rule_step.f
c Theta-rule scheme for the 1-D heat equation.
c Langtangen (2003) - Diffpack, Sect. 1.7.6, p. 127.
c Miroslav Broz (miroslav.broz@email.cz), Jul 17th 2007

      subroutine theta_rule_step(u_n_minus_1,N,dt,dx,D,theta,u_n)

      implicit none
      include 'dimen.inc'
      integer N
      real*8 u_n_minus_1(0:N),u_n(0:N),dt,dx,D,theta
      real*8 r(0:N)
      real*8 a(0:Nmax),b(0:Nmax),c(0:Nmax)

      integer i,i1st
      real*8 p1,p2
      data i1st /1/
      save p2,i1st
c saved arrays have to be static!
      save a,b,c

c 1st time initialisation of the tri-diagonal matrix A ~ a,b,c
      if (i1st.eq.1) then
        p1 = theta * D*dt/dx**2
        p2 = (1-theta) * D*dt/dx**2

        do i = 1,N-1
          a(i) = -p1
          b(i) = 1.d0+2*p1
          c(i) = -p1
        enddo
        a(0) = 0.d0
        b(0) = 1.d0
        c(0) = 0.d0
        a(N) = 0.d0
        b(N) = 1.d0
        c(N) = 0.d0
        i1st = 0
      endif

c right side of the equation system A u_n = r
      do i = 1,N-1
        r(i) = u_n_minus_1(i) + p2 *
     :    (u_n_minus_1(i-1) - 2*u_n_minus_1(i) + u_n_minus_1(i+1))
      enddo
      r(0) = u_n_minus_1(0)
      r(N) = u_n_minus_1(N)

      call tridag(a,b,c,r,u_n,N+1)

      return
      end


