c tridag.f
c Numerical Recipes (http://www.nr.com), Section 2.4

      SUBROUTINE tridag(a,b,c,r,u,n)

      INTEGER n
      REAL*8 a(n),b(n),c(n),r(n),u(n)
c      INTEGER NMAX
c      PARAMETER (NMAX=500)
c Solves for a vector u(1:n) of length n the tridiagonal linear set given by equation (2.4.1).
c a(1:n), b(1:n), c(1:n), and r(1:n) are input vectors and are not modified.
c Parameter: NMAX is the maximum expected value of n.
      INTEGER j
c One vector of workspace, gam is needed.
      REAL*8 bet
c      REAL gam(NMAX)
      REAL*8 gam(n)

      if (b(1).eq.0.) pause 'tridag.f: rewrite equations'
c If this happens then you should rewrite your equations as a set of order N-1, with u_2
c trivially eliminated.
      bet=b(1)
      u(1)=r(1)/bet
c Decomposition and forward substitution.
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
c Algorithm fails; see below.
        if (bet.eq.0.) pause 'tridag.f: tridag failed'
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    enddo
c Backsubstitution.
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    enddo

      return
      END


